#ifndef HANDLE_GUARD_H
#define HANDLE_GUARD_H

#include "windows.h"

namespace pml
{
	class CHandleGuard
	{
		HANDLE h_;
		CHandleGuard(CHandleGuard&);
		CHandleGuard& operator=(CHandleGuard&);
	public:
		explicit CHandleGuard(HANDLE h=0)
			:h_(h){}
		~CHandleGuard(void)
		{
			if(h_)CloseHandle(h_);
		}
		HANDLE get() const {return h_;}
		HANDLE release()
		{
			HANDLE tmp = h_;
			h_ = 0;
			return tmp;
		}
		void reset(HANDLE h)
		{
			if(h_)CloseHandle(h_);
			h_ = h;
		}
	};

	class CLocalAllocGuard
	{
		void * h_;
		CLocalAllocGuard(const CLocalAllocGuard&);
		CLocalAllocGuard& operator=(const CLocalAllocGuard&);
	public:
		explicit CLocalAllocGuard(void * h)
			:h_(h){}
		~CLocalAllocGuard()
		{
			if(h_) LocalFree(h_); 
		}
		void * release()
		{
			void * hRes = h_;
			h_ = 0;
			return hRes;
		}
	};
} //nm

#endif HANDLE_GUARD_H