#ifndef STRING_UTILS_H_
#define STRING_UTILS_H_

namespace strUtil
{
	inline bool IsFileNameSepartor(wchar_t ch)
	{
		return ch==L'/' || ch==L'\\';
	}

	template<class StringType>
	typename StringType::size_type GetFileNameIndex(const StringType & string)
	{
		typename StringType::size_type index = string.size();
		while(true)
		{
			if (index == 0)
				return StringType::npos;

			--index;

			if (IsFileNameSepartor(string[index]))
				return index;
		}
	}

	template<class StringType>
	StringType GetFilePath(const StringType & string)
	{
		typename StringType::size_type offset = GetFileNameIndex(string);
		if (offset == StringType::npos)
			return StringType();
		return StringType(string.begin(), string.begin()+offset);
	}

} //nm
#endif //STRING_UTILS_H_