#include "stdafx.h"
#include "ServiceWork.h"

#include <initguid.h>

using namespace sm;
const std::wstring ServiceWork::m_serviceName = L"SessMon";

SERVICE_STATUS ServiceWork::m_serviceStatus; 
SERVICE_STATUS_HANDLE ServiceWork::m_serviceStatusHandle = NULL ; 

WinNotificationEvent ServiceWork::m_cancelEvent;
WinNotificationEvent ServiceWork::m_stopedEvent;

std::auto_ptr<CThreadManager> ServiceWork::m_threadMgrPtr;

DWORD g_ThreadId(0);

static LONG WINAPI filter(struct _EXCEPTION_POINTERS *ExceptionInfo)
{
    MessageBoxA(0, "Filter", "Error", MB_OK);    
    return  EXCEPTION_CONTINUE_SEARCH;
}

void WINAPI ServiceWork::ServiceMain(DWORD argc, LPTSTR *argv)
{
#ifdef _DEBUG
    //MessageBoxA(NULL, "Wait for attach debugger...", "Debug", MB_OK);
#endif 

    g_ThreadId = GetCurrentThreadId();

    SetUnhandledExceptionFilter( filter );

    ZeroMemory (&m_serviceStatus, sizeof(SERVICE_STATUS)); 
    m_serviceStatus.dwServiceType = SERVICE_WIN32; 
    m_serviceStatus.dwCurrentState = SERVICE_RUNNING;
    m_serviceStatus.dwControlsAccepted = SERVICE_ACCEPT_STOP;
    m_serviceStatus.dwWin32ExitCode = 0;
    m_serviceStatus.dwServiceSpecificExitCode = 0;
    m_serviceStatus.dwCheckPoint = 0;
    m_serviceStatus.dwWaitHint = 0;

    m_serviceStatusHandle = RegisterServiceCtrlHandlerEx(m_serviceName.c_str(), ServiceWork::ServiceCtrlHandler, NULL); 
    if (m_serviceStatusHandle == (SERVICE_STATUS_HANDLE)0) 
    {
        //TODO: write to log
    }
    else
    {
        try
        {
            if (!SetServiceStatus (m_serviceStatusHandle, &m_serviceStatus))
            {
                //TODO: write to log GetLastError();
            }
            else
            {
                m_threadMgrPtr.reset(new CThreadManager);
                Work();
            }
        }
        catch(const std::exception &)
        {
            //TODO: write to log
        }
    }
}

void ServiceWork::Work()
{
        MSG msg;
        while(GetMessage(&msg,0,0,0))
        {
            TranslateMessage(&msg);
            DispatchMessage(&msg);
            if (m_cancelEvent.wait(0))
            {
                break;
            }
        }
    m_stopedEvent.set();
}

void ServiceWork::StopServiceHandler()
{
    try
    {
        m_cancelEvent.set();
        PostThreadMessage(g_ThreadId, WM_QUIT, NULL, NULL);
        m_stopedEvent.wait();
        m_threadMgrPtr.reset();
        
    }
    catch (const std::exception &) 
    {
        //TODO: write to log
    }
}


DWORD WINAPI ServiceWork::ServiceCtrlHandler(DWORD    dwControl,
                                             DWORD    dwEventType,
                                             LPVOID   lpEventData,
                                             LPVOID   lpContext) 
{
    switch(dwControl)
    {
    case SERVICE_CONTROL_STOP:
        {
            //TODO: write to log
            m_serviceStatus.dwWin32ExitCode = 0;
            m_serviceStatus.dwCurrentState = SERVICE_STOPPED;
            m_serviceStatus.dwCheckPoint = 0;
            m_serviceStatus.dwWaitHint = 0;
            SetServiceStatus(m_serviceStatusHandle, &m_serviceStatus);
            
            StopServiceHandler();
        }
        break;
    }
    return 0;
}

std::wstring ServiceWork::GetServiceName()
{
    return m_serviceName;
}