#ifndef _SERVICE_WORK_H_
#define _SERVICE_WORK_H_

#include "ThreadManager.h"
#include "WEvent.h"

class sm::WinNotificationEvent;

class ServiceWork 
{
public:

	static void WINAPI ServiceMain(DWORD argc, LPTSTR *argv);
    static std::wstring GetServiceName();

private:
    static const std::wstring m_serviceName;
	static void Work();
    static DWORD WINAPI ServiceCtrlHandler(
        DWORD    dwControl,
        DWORD    dwEventType,
        LPVOID   lpEventData,
        LPVOID   lpContext);
    static void StopServiceHandler();

	static SERVICE_STATUS m_serviceStatus; 
	static SERVICE_STATUS_HANDLE m_serviceStatusHandle;
	
	static sm::WinNotificationEvent m_cancelEvent;
	static sm::WinNotificationEvent m_stopedEvent;

    static std::auto_ptr<CThreadManager> m_threadMgrPtr;
};

#endif // _SERVICE_WORK_H_