#ifndef C_THREAD_MANAGER_H_
#define C_THREAD_MANAGER_H_

#include <string>
#include "SessionManager.h"
#include "SessionOwner.h"
#include "SObserver.h"
#include "boost/thread.hpp"

class CThreadManager
{
    sm::CSessionManager m_sessMgr;
    boost::thread m_thread;

    pml::CSObserver m_observer;

public:
    CThreadManager()
        : m_sessMgr(&m_observer)
        , m_thread(boost::ref(m_sessMgr))
    {
    }

    ~CThreadManager()
    {
        m_sessMgr.StopSessionManager();
        m_thread.join();
    }
};

#endif //C_THREAD_MANAGER_H_
